de.caff.generics

## Class CharIndexable.Base

- java.lang.Object
- - de.caff.generics.CharIndexable.Base

- All Implemented Interfaces:
    CharIndexable, PrimitiveCharIterable, Sizeable, java.lang.Comparable<CharIndexable>, java.lang.Iterable<java.lang.Character>
  Direct Known Subclasses:
    MutableCharIndexable.Base
  Enclosing interface:
    CharIndexable

      public abstract static class CharIndexable.Base
      extends java.lang.Object
      implements CharIndexable, java.lang.Comparable<CharIndexable>

  Abstract base class which provides useful implementations for `Object.equals(Object)`, `Object.hashCode()`, `Object.toString()`. It also provides `Comparable.compareTo(Object)`.
  See Also:
    `CharIndexable.asBase()`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface de.caff.generics.CharIndexable

      `CharIndexable.Base`

  - ### Field Summary

    - ### Fields inherited from interface de.caff.generics.CharIndexable

      `EMPTY`

    - ### Fields inherited from interface de.caff.generics.PrimitiveCharIterable

      `EMPTY_CHAR_ITERATOR`

    - ### Fields inherited from interface de.caff.generics.Sizeable

      `NULL`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Base()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CharIndexable.Base` | `asBase()` Make this char indexable usable as a class with defined standard Object methods.
    `int` | `compareTo(CharIndexable o)`
    `boolean` | `equals(java.lang.Object obj)`
    `int` | `hashCode()`
    `java.lang.String` | `toString()` Get a string representation of this indexable.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface de.caff.generics.CharIndexable

      `addAllTo, addToArray, addToArray, addToArray, addToArray, asCharSequence, asCollection, asIndexable, asIntIndexable, asList, binarySearch, binarySearch, charIterator, charIterator, compare, emptyIndexable, equal, equal, firstMatch, foldLeft, frozen, get, getMod, gyt, hash, headSet, indexes, init, initByIndex, intIndexes, intIterator, isEmpty, isOrdered, isOrdered, isStrictlyOrdered, isStrictlyOrdered, iterator, lastMatch, listIterator, makeString, nextMatch, ordered, previousMatch, reverse, rotated, singleton, subSet, sybSet, tailSet, toArray, toIntArray, toList, toString, toText, view, viewArray, viewArray, viewArray, viewAsBoolean, viewAsCharSequence, viewByIndex, viewChars, viewIndexable, viewIndexable, viewIndexable, viewList, viewList, viewList, viewOp, viewString, withAppendedValue, withExchangedValueAt, withInsertedValueAt, withRemovedValueAt, withSwappedValuesAt`

    - ### Methods inherited from interface de.caff.generics.PrimitiveCharIterable

      `asIntIterable, asLongIterable, containsChar, forEachChar, forEachCharFragile`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, spliterator`

    - ### Methods inherited from interface de.caff.generics.Sizeable

      `size`

- - ### Constructor Detail

    - #### Base

          public Base()

  - ### Method Detail

    - #### compareTo

          public int compareTo(@NotNull
                               CharIndexable o)

      Specified by:
        `compareTo` in interface `java.lang.Comparable<CharIndexable>`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### equals

          public boolean equals(java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Get a string representation of this indexable.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        string representation representing the indexable nature of the contained characters, use `CharIndexable.makeString()` to get a simple concatenated string

    - #### asBase

          @NotNull
          public CharIndexable.Base asBase()

      Description copied from interface: `CharIndexable`
      Make this char indexable usable as a class with defined standard Object methods.
      Specified by:
        `asBase` in interface `CharIndexable`
      Returns:
        based version of this indexable